WORDSTRUCT STRUC
  ASWORD DW ?
ENDS
P STRUC
  Pointer DD ?
ENDS

; ---------------------------------------------------------------------------
;
; KEYBOARD ENGINE
;

.MODEL medium
.386
.CODE

 KeyDownValue DB 16 DUP (0)
 OldInt9off DW 0
 OldInt9seg DW 0
 KeyInterruptState DW 0
 KeyActive DB 0

; ---------------------------------------------------------------------------
; InstallKeyboard SUB
; purpose:
;   Installs a keyboard interrupt handler that updates the status of each key
; declaration:
;   DECLARE SUB InstallKeyboard(BYVAL State%)
; ---------------------------------------------------------------------------
; State is a set of bits as follows
; bit 0 Held Down Test Active if set
; bit 1 Typing Buffer Available if set
PUBLIC INSTALLKEYBOARD
INSTALLKEYBOARD:
  CMP KeyActive,1
  JE EndKeyInstall

  PUSH BP
  MOV BP, SP
  MOV AX, [BP + 6]
  MOV KeyInterruptState,  AX

  TEST KeyInterruptState, 2
  JNZ KeepKeyboardFlags1

  MOV AX,040h
  MOV ES,AX
  MOV SI,017h
  MOV AL,ES:[SI]
  AND AL,0F0h
  MOV ES:[SI], AX
  MOV SI, 1Ah
  MOV [SI].ASWORD, 1Eh
  MOV [SI+ 2].ASWORD,  1Eh
KeepKeyboardFlags1:

  PUSH DS
  MOV AX,3509h
  INT 21h
  MOV OldInt9seg,ES
  MOV OldInt9off,BX

  MOV AX,SEG KeyboardISR
  MOV DX,OFFSET KeyboardISR
  MOV DS,AX
  MOV AX,2509h
;Version For TESTCOM
  ;MOV AX,2580h

  INT 21h
  POP DS
  POP BP
  MOV KeyActive,1

EndKeyInstall:
  RETF 2


KeyboardISR:

  PUSH AX
  PUSH BX
  PUSH CX
;Are we doing hold down?
  TEST KeyInterruptState, 1
  JZ WrapUp

  XOR AX, AX
  IN AL,60h
  TEST AL,80h
  JZ StoreStatus
;Clear Up/DownStatus
  AND AL,7Fh
  MOV CL, AL
  AND CL, 7
  SHR AL, 3
  MOV BX, AX
  MOV AL, 0FEh
  ROL AL, CL
  AND  [BX + KeyDownValue] , AL
 
JMP SHORT WrapUp

StoreStatus:

  MOV CL, AL
  AND CL, 7
  SHR AL, 3
  MOV BX, AX
  MOV AL, 1
  ROL AL, CL
  OR  [BX + KeyDownValue] , AL

WrapUp:
;Are We Doing Typing Buffer
  TEST KeyInterruptState, 2
  JZ WeWrap
  POP CX
  POP BX
  POP AX

  JMP OldInt9off.Pointer
WeWrap:
  IN AL,61h
  OR AL,80h
  OUT 61h,AL
  MOV AL,20h
  OUT 20h,AL

  POP CX
  POP BX
  POP AX
  IRET


; ---------------------------------------------------------------------------
; removeKeyboard SUB
; purpose:
;   Removes previously installed keyboard interrupt handler and restores
;   the old one
; declaration:
;   DECLARE SUB removeKeyboard()
; ---------------------------------------------------------------------------
PUBLIC REMOVEKEYBOARD
REMOVEKEYBOARD:
  CMP KeyActive,0
  JE EndKeyRemove
  MOV KeyActive, 0
  PUSH DS
  MOV DX,OldInt9off
  MOV AX,OldInt9seg
  MOV DS,AX
  MOV AX,2509h
  INT 21h
  POP DS

  MOV [KeyDownValue].ASWORD, 0
  MOV [KeyDownValue + 2].ASWORD, 0
  MOV [KeyDownValue + 4].ASWORD, 0
  MOV [KeyDownValue + 6].ASWORD, 0
  MOV [KeyDownValue + 8].ASWORD, 0
  MOV [KeyDownValue +10].ASWORD, 0
  MOV [KeyDownValue +12].ASWORD, 0
  MOV [KeyDownValue + 14].ASWORD, 0

EndKeyRemove:
  RETF

; ---------------------------------------------------------------------------
; KeyDown SUB
; purpose:
;   Reads the key flags
; declaration:
;   DECLARE FUNCTION KeyDown(BYVAL SoughtKey%)
; ---------------------------------------------------------------------------

PUBLIC KEYDOWN
KEYDOWN:
  PUSH BP
  MOV BP, SP
  MOV BX, [BP + 6]
  MOV CL, BL
  AND CL, 7
  SHR BL, 3
  MOV AL, 1
  ROL AL, CL
  TEST AL, [BX + KeyDownValue]
  JNZ SetKeyDown
  XOR AX, AX
  POP BP
RETF 2
SetKeyDown:
  MOV AX, 0FFFFh
  POP BP
RETF 2

PUBLIC CHANGEKEYBOARDACCESS
CHANGEKEYBOARDACCESS:
  PUSH BP
  MOV BP, SP
  MOV AX, [BP + 6]
  MOV KeyInterruptState, AX

  TEST KeyInterruptState, 2
  JNZ KeepKeyboardFlags2

  MOV AX,040h
  MOV ES,AX
  MOV SI,017h
  MOV AL,ES:[SI]
  AND AL,0F0h
  MOV ES:[SI], AX
  MOV SI, 1Ah
  MOV [SI].ASWORD, 1Eh
  MOV [SI+ 2].ASWORD,  1Eh
KeepKeyboardFlags2:
  TEST KeyInterruptState, 1
  JNZ  ChangeKeyboardAccessEnd
  MOV [KeyDownValue].ASWORD, 0
  MOV [KeyDownValue + 2].ASWORD, 0
  MOV [KeyDownValue + 4].ASWORD, 0
  MOV [KeyDownValue + 6].ASWORD, 0
  MOV [KeyDownValue + 8].ASWORD, 0
  MOV [KeyDownValue +10].ASWORD, 0
  MOV [KeyDownValue +12].ASWORD, 0
  MOV [KeyDownValue + 14].ASWORD, 0
ChangeKeyboardAccessEnd:
  POP BP

RETF 2
END

